﻿using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeUltraComboEditorList();
            InitializeUltraTreeDataTable();
        }

        private void InitializeUltraComboEditorList()
        {
            this.ultraComboEditor1.Items.Add(null, "<select value>");
            this.ultraComboEditor1.Items.Add("MAIN", "Value 1");
            this.ultraComboEditor1.Items.Add("SECOND", "Value 2");
            this.ultraComboEditor1.Items.Add("THIRD", "Value 3");
            this.ultraComboEditor1.Items.Add("FOURTH", "Value 4");
        }

        private void InitializeUltraTreeDataTable()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Values", typeof(string));

            DataRow currentRow = table.NewRow();
            currentRow[0] = "SECOND";
            table.Rows.Add(currentRow);
            currentRow = table.NewRow();
            currentRow[0] = "THIRD";
            table.Rows.Add(currentRow);
            currentRow = table.NewRow();
            currentRow[0] = "FOURTH";
            table.Rows.Add(currentRow);
            currentRow = table.NewRow();
            currentRow[0] = "MAIN";
            table.Rows.Add(currentRow);

            this.ultraTree1.DataSource = table;
        }

        private void ultraTree1_AfterSelect(object sender, Infragistics.Win.UltraWinTree.SelectEventArgs e)
        {
            // Uncomment to reproduce the issue
            // this.ultraComboEditor1.Text  = e.NewSelections[0].Text;
            UltraTreeNode currentNode = e.NewSelections[0];
            ValueList ultraComboValueList = this.ultraComboEditor1.ValueList;
            ValueListItem selectedItem = ultraComboValueList.ValueListItems.Cast<ValueListItem>().SingleOrDefault(x => x.DataValue as String == currentNode.Text);
            this.ultraComboEditor1.SelectedItem = selectedItem as ValueListItem;
        }
    }
}
